import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class GoalMover here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Enemy extends Moving
{   public int health;  
    public int type_;
    public int reloadTime;
    public static final int FIRINGENEMY = 1;
    public static final int FINALBOSS = 2;
    //type will be 2 so only final boss has this type (Default type is 0)
    public Enemy()
    {
        turn(90);
        speed = 0;
        health = 300;       
    }
    
    public void goalReached() //game over if enemies reach the end of the level.
    {
        if (isAtEdge())
        {
            World world = getWorld();
             
            int halfWidth = world.getWidth();
            int halfHeight = world.getHeight();
            
            world.addObject(new GameOver("Game Over.\nThe enemy escaped your wrath."),halfWidth,halfHeight);
            Greenfoot.stop();
        }
    }
    
    public void setType(int type)
    {
        type_ = type;
    }
    
    public int scoreValue()
    {
        int scoreValue = 1; //each enemy will deduct one from the enemies left
        return scoreValue;
    }

    public void remove()
    {
        if (isTouching(Invincibility.class)) //is combusted if touching shield
        {
            World world = getWorld();
            world.addObject(new Combustion(),this.getX(),this.getY());

            Ground ground = (Ground)getWorld();
            ScoreBoard scoreBoard = ground.scoreBoardIndicator();
            scoreBoard.update(scoreValue());
            
            world.removeObject(this);
        }
        else if (health <= 0) //is killed if health <= 0
        {
           World world = getWorld();
            
           Ground ground = (Ground)getWorld();
           ScoreBoard scoreBoard = ground.scoreBoardIndicator();
           scoreBoard.update(scoreValue());
            
           death();
           world.removeObject(this);
        }
    }
    
    /**
     * Act - do whatever the Enemy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        move(speed);
        goalReached();
        victory();
        remove();
    }
    
    public void health(int h) //allows health to be adjusted in all enemies
    {
        health = h;
    }
    
    public void takeDamage(int damageTaken) /*method takeDamage(int) removes (int)
                                              health from player's health*/
    {
        health -= damageTaken;
    }
    
    public void turnTowardsPlayer() //allows some enemies to turn towards player
    {
        List players = getObjectsInRange(1000,Player.class);
        if (players.size() > 0) //only tracks player if it is on the map
        {
            Player player = (Player)players.get(0);
            turnTowards(player.getX(),player.getY());
        }   
    }
    
    public void death() //plays animation when any enemy dies
    {
        int x = getX();
        int y = getY();
        
        World world = getWorld();
        DeathExplosion deathAnimation = new DeathExplosion();
        world.addObject(deathAnimation,x,y);
    }  
    
    public void reloadTime() //sets a reload time
    {   
        getReloadTime();
        reloadTime--;
        if (getReloadTime() <= 0 && type_ == FIRINGENEMY)
        {
            fire(new EnemyShot());
        }
        else if (getReloadTime() <= 0 && type_ == FINALBOSS)
        {
            fire(new FinalBossShot());
        }
    }
    
    public void fire(Weapon w)
    {      
        World world = getWorld();
        
        int x = this.getX();
        int y = this.getY();
        
        world.addObject(w,x,y);  
    }
    
    public void setReloadTime(int r) //reload time of all enemies
    {
        reloadTime = r;
    }
    
    public int getReloadTime()
    {
        return reloadTime;
    }
    
    public void victory() //runs if final boss is killed
    {
        if (health <= 0 && type_ == FINALBOSS)
        {
            World world = getWorld();
            
            int halfWidth = world.getWidth();
            int halfHeight = world.getHeight();
    
            world.addObject(new WinningExplosion(),300,200);
            world.addObject(new GameOver("You have defeated the boss." +
                                        "\nCongratulations, you win!"),halfWidth,halfHeight);
            Greenfoot.stop();
        }
    }
}