        import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Weapons here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Weapon extends Moving
{
    /**
     * Act - do whatever the Weapons wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private int type_;
    public int speed;
    public int bouncesRemaining;
    private int counter;
    public static final int BOUNCINGLASER = 4;
    public static final int FINALBOSSSHOTTYPE = 3;
    public static final int ENEMYSHOTTYPE = 2;
    public static final int MISSILETYPE = 1;
    public static final int LASERTYPE = 0;
    public Weapon()
    {
        turn(270);
        speed = 5;
        counter = 5;
    }

    public void setType(int type)
    {
        type_ = type; //weapons are assigned a type to decide what they do
    }
    public void act() 
    {
        processWeapon();
        move(speed);
    }
    
    public void processWeapon()
    {
        World world = getWorld();
        if (isAtEdge())
        {
            world.removeObject(this);
        }
        else if (isTouching(Enemy.class) && type_ == LASERTYPE)
        {   //if a laser hits enemy, remove 25 health and remove the laser.
            removeHealth(25);
            world.removeObject(this);
        }
        else if (((Enemy)getOneIntersectingObject(FinalBoss.class)!=null)
                && (type_ == MISSILETYPE || type_ == BOUNCINGLASER)) //missiles are ineffective
        {   //if a missile or bouncing laser hits the final boss, destroy the weapon.
            world.addObject(new Combustion(),this.getX(),this.getY());
            world.removeObject(this);
        }
        else if (((Enemy)getOneIntersectingObject(Enemy.class)!=null)
                && type_ == MISSILETYPE)
        {   //if a missile hits an enemy, run "splashDamage()".
            splashDamage();
        }
        else if (isTouching(Player.class) &&
                 (type_ == ENEMYSHOTTYPE || type_ == FINALBOSSSHOTTYPE))
        {   //if an enemy weapon hits the player, remove the player.
            List players = getObjectsInRange(1000,Player.class);
            Player player = (Player)players.get(0);
            world.removeObject(this);
            world.removeObject(player);
        }
        else if (type_ == BOUNCINGLASER && isTouching(Enemy.class))
        {   //if your bouncing laser hits an enemy, continue bouncing until bouncesRemaining reaches 0
            if (bouncesRemaining > 0)
            {
                removeHealth(300);
                bouncesRemaining--; //subtract 300 hp (one shot kill) and one bounce for each hit
            }
            else if (bouncesRemaining <= 0)
            {
                world.removeObject(this); //no bounces left, remove the laser.
            }
        }
    }

    public void explode()
    {
        int x = getX();
        int y = getY();
        
        World world = getWorld();
        MissileExplosion explosion = new MissileExplosion();
        world.addObject(explosion,x,y);
        world.removeObject(this);
    }     
    
    public void splashDamage()
    {
        List<Enemy> wreckedEnemies = getObjectsInRange(250,Enemy.class);
        World world = getWorld();
        world.removeObjects(wreckedEnemies);
        
        int size = wreckedEnemies.size();
        Ground ground = (Ground)getWorld();
        ScoreBoard scoreBoard = ground.scoreBoardIndicator();
        scoreBoard.update(size);
        
        explode();
    }
    
    public void removeHealth(int x)
    {
        Enemy attacked = (Enemy)getOneIntersectingObject(Enemy.class);
        attacked.takeDamage(x);
    }
    
    public void firstSecond() //only fires towards the player, does not track
    {
        counter--;
        if (counter > 0)
        {
            turnTowardsPlayer();
        }
    }
    
    public void turnTowardsPlayer()
    {
        List players = getObjectsInRange(1000,Player.class);
        if (players.size() > 0)
        {
            Player player = (Player)players.get(0);
            turnTowards(player.getX(),player.getY());
        }   
    }
}
